#include "jpegfile.h"
#include "xml_node.h"
#include "in_jpg.h"


namespace image_loader {

	IntPtr  image_loader::Load_Image(String^ fname, IntPtr ptr, IntPtr size, IntPtr buffer)
	{
		UINT width, height;
		BYTE *dataBuf;
		char* filename = StringToCharstring(fname);

		//read the file
		dataBuf=JpegFile::JpegFileToDWORDAlignedBGR(filename, &width, &height, (int*)(void*)ptr, (int*)(void*)size, (BYTE**)(void*)buffer);
		delete [] filename;
		if (!dataBuf) return IntPtr(0);

		xml_node^ t;
		xml_node^ image_description = gcnew xml_node( nullptr, "OutputImage", "", "" );
		image_description->children.Add( gcnew xml_node(image_description, "Width", "", width.ToString()) );
		image_description->children.Add( gcnew xml_node(image_description, "Height", "", height.ToString()) );
		image_description->children.Add( gcnew xml_node(image_description, "Stride", "", (((width * 3 + 3) / 4) * 4).ToString()) );
		image_description->children.Add( gcnew xml_node(image_description, "Packed", "", "1") );
		image_description->children.Add( gcnew xml_node(image_description, "Interleaved", "", "1") );
		image_description->children.Add( gcnew xml_node(image_description, "ChannelCount", "", "3") );
		image_description->children.Add( gcnew xml_node(image_description, "PixelSize", "", "24") ); // in bits
		image_description->children.Add( gcnew xml_node(image_description, "Data", "", ((unsigned int)(void*)dataBuf).ToString()) );
		image_description->children.Add( t = (gcnew xml_node(image_description, "ChannelsBitAllocation", "", "") ) );
		t->children.Add( gcnew xml_node( t, "Channel0", "", "8" ) );
		t->children.Add( gcnew xml_node( t, "Channel1", "", "8" ) );
		t->children.Add( gcnew xml_node( t, "Channel2", "", "8" ) );

		return (IntPtr)((void*)(image_description->XML_Tree_Marshal()));
	}


	IntPtr image_loader::GetImageProperties(String^ fname)
	{
		UINT width, height;
		char* filename = StringToCharstring(fname);

		//read the file
		if (!JpegFile::GetJPGDimensions(filename, &width, &height))
		{
			delete [] filename;
			return IntPtr(0);
		}
		delete [] filename;

		xml_node^ t;
		xml_node^ image_description = gcnew xml_node( nullptr, "OutputImage", "", "" );
		image_description->children.Add( gcnew xml_node(image_description, "Width", "", width.ToString()) );
		image_description->children.Add( gcnew xml_node(image_description, "Height", "", height.ToString()) );
		image_description->children.Add( gcnew xml_node(image_description, "Stride", "", (((width * 3 + 3) / 4) * 4).ToString()) );
		image_description->children.Add( gcnew xml_node(image_description, "Packed", "", "1") );
		image_description->children.Add( gcnew xml_node(image_description, "Interleaved", "", "1") );
		image_description->children.Add( gcnew xml_node(image_description, "ChannelCount", "", "3") );
		image_description->children.Add( gcnew xml_node(image_description, "PixelSize", "", "24") ); // in bits
		image_description->children.Add( gcnew xml_node(image_description, "Data", "", "0") );
		image_description->children.Add( t = (gcnew xml_node(image_description, "ChannelsBitAllocation", "", "") ) );
		t->children.Add( gcnew xml_node( t, "Channel0", "", "8" ) );
		t->children.Add( gcnew xml_node( t, "Channel1", "", "8" ) );
		t->children.Add( gcnew xml_node( t, "Channel2", "", "8" ) );

		return (IntPtr)((void*)(image_description->XML_Tree_Marshal()));
	}
}
